#!/bin/bash

### BEGIN INIT INFO
# Provides:          php-fastcgi
# Required-Start:    $local_fs $remote_fs $network $syslog
# Required-Stop:     $local_fs $remote_fs $network $syslog
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: starts the php-fastcgi processmanager for nginx
# Description:       starts php-fastcgi using start-stop-daemon
### END INIT INFO                                             

# jg, Thu May  2 14:12:34 CEST 2013
# - Basis war mal
#   http://library.linode.com/web-servers/nginx/php-fastcgi/debian-6-squeeze
# - Umgebaut und Angepasst an lsb/init-functions
#   Hints dazu aus: http://www.thegeekstuff.com/2012/03/lsbinit-script/

PHP_SCRIPT=/usr/bin/php-fastcgi
FASTCGI_USER=www-data
FASTCGI_GROUP=www-data
PID_DIR=/var/run/php-fastcgi
PIDFILE=/var/run/php-fastcgi/php-fastcgi.pid
RET_VAL=0

# Fuer lsb init-functions Standard
DAEMON=$PHP_SCRIPT
NAME="php-fastcgi"

test -x $DAEMON || exit 0

set -e

. /lib/lsb/init-functions

test_php_fastcgi_pid_dir() {
    if [ ! -d $PID_DIR ]
    then
        mkdir $PID_DIR
        chown $FASTCGI_USER:$FASTCGI_GROUP $PID_DIR
        chmod 0770 $PID_DIR
    fi    
}

case "$1" in
    start)
	
	test_php_fastcgi_pid_dir

         # Checked the PID file exists and check the actual status of process
	if [ -e $PIDFILE ]; then
	    status_of_proc -p $PIDFILE $DAEMON "$NAME process" && status="0" || status="$?"
            # If the status is SUCCESS then don't need to start again.
	    if [ $status = "0" ]; then
		exit # Exit
	    fi
	fi
        # Start the daemon.
	log_daemon_msg "Starting the process" $NAME
	log_end_msg 0
        # Start the daemon with the help of start-stop-daemon
        # Log the message appropriately
	if start-stop-daemon --start --quiet --oknodo --pidfile $PIDFILE --exec $DAEMON ; then
	    log_end_msg 0
	else
	    log_end_msg 1
	fi
	RET_VAL=$?
	;;
    stop)

	# Stop the daemon.
	if [ -e $PIDFILE ]; then
	    status_of_proc -p $PIDFILE $DAEMON "$NAME process" > /dev/null && status="0" || status="$?"
	    if [ "$status" = 0 ]; then
		log_daemon_msg "Stopping the process" $NAME
		log_end_msg 0
		start-stop-daemon --stop --quiet --oknodo --pidfile $PIDFILE
		/bin/rm -rf $PIDFILE
	    fi
	else
	    log_daemon_msg "Process is not running" $NAME
	    log_end_msg 1
	fi
	RET_VAL=$?
	;;
    restart)
	
	log_daemon_msg "Restart process" $NAME
	log_end_msg 0
        # Restart the daemon.
	$0 stop && sleep 2 && $0 start
	
	;;
    status)
        # Check the status of the process.
	if [ -e $PIDFILE ]; then
	    status_of_proc -p $PIDFILE $DAEMON "$NAME process" && exit 0 || exit $?
	else
	    log_daemon_msg "$NAME Process is not running"
	    log_end_msg 1
	fi
	RET_VAL=$?
	;;
    *)
	echo "Usage: $0 {start|stop|restart|status}"
	RET_VAL=1
	;;
esac
exit $RET_VAL

